#
# PVM Implementation
#

newPVMnode <- function(where = "",
                       options = defaultClusterOptions) {
    # **** allow some form of spec here
    # **** make sure options are quoted
    rhome <- getClusterOption("rhome", options)
    script <- file.path(getClusterOption("scriptdir", options), "RPVMnode.sh")
    rlibs <- paste(getClusterOption("rlibs", options), collapse = ":")
    args <- c(paste("RPROG=", getClusterOption("rprog", options), sep=""),
              paste("OUT=", getClusterOption("outfile", options), sep=""),
              paste("R_LIBS=", rlibs, sep=""),
              script)
    tid <- .PVM.spawn(task="/usr/bin/env", arglist = args, where = where)
    structure(list(tid = tid, RECVTAG = 33,SENDTAG = 22), class = "PVMnode")
}

makePVMmaster <- function()
    structure(list(tid = .PVM.parent (), RECVTAG = 22, SENDTAG = 33),
              class = "PVMnode")

sendTag.PVMnode <- function(node, tag) {
    .PVM.initsend ()
    .PVM.pkstrvec (tag)
    .PVM.send (node$tid, node$SENDTAG)
}

recvTag.PVMnode <- function(node) {
    .PVM.recv (node$tid, node$RECVTAG)
    .PVM.upkstrvec ()
}

# old versions using deparse/parse
sendData.PVMnode <- function(node, data) {
    ddata <- deparse(if (is.language(data)) enquote(data) else data)
    .PVM.initsend ()
    .PVM.pkstrvec (ddata)
    .PVM.send (node$tid, node$SENDTAG)
}

recvData.PVMnode <- function(node) {
    .PVM.recv (node$tid, node$RECVTAG)
    eval(parse(text = .PVM.upkstrvec ()))
}

# these require rpvm with serialization support
sendData.PVMnode <- function(node, data) {
    .PVM.initsend ()
    .PVM.serialize(data, node$con)
    .PVM.send (node$tid, node$SENDTAG)
}

recvData.PVMnode <- function(node) {
    .PVM.recv (node$tid, node$RECVTAG)
    .PVM.unserialize(node$con)
}

makePVMcluster <- function(count, ..., options = defaultClusterOptions) {
    if (! require(rpvm))
        stop("the `rpvm' package is needed for PVM clusters.")
    options <- addClusterOptions(options, ...)
    cl <- vector("list",count)
    for (i in seq(along=cl))
        cl[[i]] <- newPVMnode(options = options)
    cl
}
